REBOL [
	Title: "REBOL/Services - Misc. Definitions"
	Author: "Carl Sassenrath"
	Notice: "Confidential source code. Under development."
	Copyright: "REBOL Technology 2005-2008, All rights reserved."
]

;-- Definitions --------------------------------------------------------------

null: to-char 0

rebol-port-id: 2997

base-dir: none ; base for services (set by LOAD-CONFIG)

; User level errors:
do-error: func [val] [make error! reform val]

; PUT is same as POKE but with less stigma:
put: :poke

; Useful word-based block mapping function:
map-words: func [
	"Map data order using words. Ex: [a b c d] [b c] [1 2 3 4] = [2 3]"
	from to data
][
	use from [
		set bind from first from data
		reduce bind to first from
	]
]

charset-crlf: charset crlf

copy-line: func [
	"Copy a single line of text only."
	str
][
	copy/part str any [find str charset-crlf tail str]
]

limit-str: func [
	"Clear string at given length."
	str
	size
][
	clear skip str size
	str
]

open?: func [
	"Returns TRUE if port is OPEN."
	port [port! none!]
][
	found? all [
		port? port
		port/status = 'open
		positive? port/state/flags and 512
	]
]

reset-async-port: func [
	"Reset async port to use over (only if closed!)"
	port
][
	; This is a hack. Needs to be done internally somehow in REBOL.
	port/state/misc/1: 0
	port/state/flags: 0
]
